﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Microsoft.SharePoint.Client;
using System.Net;

namespace ClientOM
{
    public partial class Form1 : System.Windows.Forms.Form
    {

        ClientContext clientContext;
        Web web;
        List list;
        ListItemCollection items;


        public List<Task> CurrentTasks = new List<Task>();

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            clientContext = new ClientContext(txtUrl.Text);

            web = clientContext.Web;
            list = web.Lists.GetByTitle("Tasks");
            CamlQuery query = new CamlQuery();
            query.ViewXml = "<View><ViewFields><FieldRef Name=\"Title\" /><FieldRef Name=\"Department\" /><FieldRef Name=\"StartDate\" /><FieldRef Name=\"Priority\" /><FieldRef Name=\"Status\" /></ViewFields><RowLimit>100</RowLimit></View>";

            items = list.GetItems(query);
            
            // Using Include
            //clientContext.Load(items,itemz => itemz.Include(item => item["Title"]));        
            clientContext.Load(web);
            clientContext.Load(items);
            clientContext.ExecuteQuery();

            foreach (ListItem item in items)
            {
                Task t = new Task();
                t.ID = Int32.Parse( item.FieldValues["ID"].ToString());
                t.Title = item.FieldValues["Title"] as string;
                t.StartDate = DateTime.Parse(item.FieldValues["StartDate"].ToString());
                t.Priority = item.FieldValues["Priority"] as string;
                t.Status = item.FieldValues["Status"] as string;
                t.Department = item.FieldValues["Department"] as string;
                CurrentTasks.Add(t);
                //lstTasks.Items.Add(item);
            }

            lstTasks.DataSource = CurrentTasks;            
        }

        private void New_Click(object sender, EventArgs e)
        {
            FillTaskForm(new Task());


        }


        private void btnSave_Click(object sender, EventArgs e)
        {
            Task task = FillTaskFromForm();
            ListItem item;

            if (task.ID > 0)
            {  //Update
                item = list.GetItemById(task.ID);
            }
            else
            {   // New Item
                ListItemCreationInformation iec = new ListItemCreationInformation();
                item = list.AddItem(iec);
            }

            FillListItemFromTask(item, task);
            item.Update();
            clientContext.ExecuteQuery();

           
        }

        

        private void btnDelete_Click(object sender, EventArgs e)
        {
            Task task = FillTaskFromForm();

            ListItem item = list.GetItemById(task.ID);
            item.DeleteObject();
            clientContext.ExecuteQuery();
            
        }

        #region Boring Binding Code
        private void FillTaskForm(Task task)
        {
            txtID.Text = task.ID.ToString();
            txtTitle.Text = task.Title;
            ddlPriority.SelectedItem = task.Priority;
            ddlStatus.SelectedItem = task.Status;
            if (task.StartDate == DateTime.MinValue)
                startDate.Value = DateTime.Now;
            else
                startDate.Value = task.StartDate.ToUniversalTime();
            txtDepartment.Text = task.Department;
        }

        private Task FillTaskFromForm()
        {
            Task task = new Task();
            if(txtID.Text.Length > 0)
                task.ID = Int32.Parse( txtID.Text);
            task.Title = txtTitle.Text;
            task.Priority = ddlPriority.Text ;
            task.Status = ddlStatus.Text ;
            task.StartDate = startDate.Value  ;
            task.Department = txtDepartment.Text ;
            return task;
        }

        private ListItem FillListItemFromTask(ListItem item, Task task)
        {
            item["Title"] = task.Title;
            
            item["StartDate"] = task.StartDate;
            item["Priority"] = task.Priority;
            item["Status"] = task.Status;
            item["Department"] = task.Department;

            return item;
        }

       
        private void lstTasks_SelectedIndexChanged(object sender, EventArgs e)
        {
            FillTaskForm(lstTasks.SelectedItem as Task);
        }
        #endregion
    }
}
